#include <vector>
#include <memory>
#include <thread>
#include <mutex>
#include <fcf/net/socket.hpp>
#include "endpoint.hpp"
#include "configuration.hpp"

namespace application {

  class server_t
  {
  public:
    server_t(const server_configuration_t& a_config);
    void run();
    void stop();
  private:
    void _handler();

    bool                         _stop;
    std::mutex                   _mutex;
    server_configuration_t       _config;
    std::vector<endpoint_sptr_t> _endpoints;
    fcf::net::socket_sptr_t      _socket;
    std::thread                  _thread;
  };

  typedef std::shared_ptr<server_t> server_sptr_t;

}
